rch@091102 (Lunes 2 de Noviembre) .....
Separé en las THidroConEmbalse y THidroConEmbalseBinacional la definición de la geometría
del embalse de los límites operativos hmin y hmax. Para ello agregué dos arrays de reales
PuntosCotaVolumen_h y PuntosCotaVolumen_V para especificar puntos de la curva cota volumen.
Por ahora el modelo espera 3 puntos. Con estos tres puntos crea un polinomio de aproximación
con el que calcula las constantes necesarias.
Este cambio llevó a 28 el contador de versión del lector de salas.

palfaro@0910011226
Se cambio el algoritmo de paralelización en memoria compartida para que en vez de crear muchos hilos cada uno con una tarea mas pequeña se creen igual cantidad de hilos que de procesadores en el sistema y multiples tareas que los hilos van pidiendo a medida que terminan sus calculos. Con esto se logro bajar los tiempos de ejecución del 75% obtenido antes a un 66%.
Se agregaron las variables NMAX_ITERACIONESDELPASO_SIM y NMAX_ITERACIONESDELPASO_OPT que controlan el máximo número de iteraciones en simulación y optimización de manera independiente y ademas se salvan con la sala. Los valores por defecto son 4 y 0
Se modificaron los formularios para soportar estas nuevas variables.
Se modificó el comportamiento de TActualizadorLPD al actualizar las fichas en la optimización, la versión anterior cada vez que correspondía un cambio por fecha iba asignando todas las fichas desde el principio hasta la fecha para todos los actores, ahora solo asigna la ficha anterior para cada actor.
Se corrigió un error menor en la optimización con sorteos donde las variables auxiliares al acumularse se dividían por el numero de sorteos y al terminar el barrido de las estrellas se dividian nuevamente por el numero de sorteos. Ahora solo se acumulan divididas por el número de sorteo.
Se corrigió un error en la optimización sin sorteos donde las variables auxiliares se intercambiaban en vez de en cada paso en cada estrella.
Se modificaron todos los formularios de edición para que utilicen la función FloatToStr de xMatDefs, en vez de la de SysUtils.


rch@0909191851 elimino la necesidad de AjusteDCF y ChequeDCF como condicional defines.
impongo que la forma de cálculo del costo futuro es por el costo directo del paso más
el costo futuro en el estado de llegada. Por lo que no son más necearias esas opciones.
Esto aumenta al eficiencia de la optimizacion un 10%.

rch@090918 , paso a 2.42b volvemos TArco a rendimiento fijo. 
rch@090917 , paso a 2.41 con control de convergencia en la Hidro con embalse.

palfaro@0909111448
Se rediseñó la estructura de clases de los formularios de alta y edición de actores y fuentes. 
Ahora todos heredan de TBaseEditoresCosasConNombre y comparten el mismo constructor y funciones de inicialización de componentes. Ya no es necesario tener un formulario de alta y uno de edición para los actores y es posible dar de alta, editar, clonar o eliminar un actor o fuente desde cualquier formulario del editor.
Ademas se quitaron los chequeos de los componentes en el momento de editar. Los chequeos solo se realizan cuando el usuario da guardar de modo de permitir trabajar con mas tranquilidad.
Falta propagar el rediseño a los monitores y utilizar las nuevas funciones de manipulación de nodos y fuentes en comboboxes en los formularios de edición de fichas de parámetros dinámicos.
Se agregaron funciones nuevas de manipulación de nodos y fuentes en comboboxes que permiten agregar un nuevo nodo o fuente desde cualquier formulario del editor, eliminando la necesidad de salir de la edición del actor actual para agregar una nueva fuente por ejemplo.
Se corrigieron errores en el calculo de los histogramas uniformes a partir de un vecotr de muestras y un vector de pesos.
Se cambió en los cosntructores de todos los actores con parámetros dinámicos que reciban una lista de parametros dinámicos y se quito la ficha inicial que no se estaba utilizando


palfaro@0909081700
Se corrigió en los formularios de edición de fichas de todas las fuentes aleatorias que xMatDefs estuviera usada luego de SysUtils de forma de redefinir StrToFloat con el método de uEvlauador
Se agregaron funciones para manipulación de tablas de números reales a TBaseFormularios
Se modificó el formulario de edición de fichas de TFuenteSintetizadorCEGH para que permita especificar un multiplicador para el valor esperado y la desviación estandar de cada borne y realize los chequeos de validez correspondientes
Se corrigió un error en las fichas periodicas donde la cantidad de años, meses, semanas o días que se aumentaban por ciclo eran ignoradas
Se modificó TFuenteSintetizadorCEGH para poder especificar multiplicadores del valor esperado y la desviación estandar de cada borne

palfaro@0908241626
Se corrigieron errores en las tablas de falla de los formularios de alta de todas las demandas
Se modificó el formulario de edición de fichas de THidroConEmbalseBinacional para que permita especificar valores de generación para el otro país en forma horaria semanal
Se modificó el comportamiento de los actores con iteraciones para que al posicionarse en estrellita inicialicen su variable de iteración anterior al mismo valor que la variable de iteración en vez de guardarla en el administrador de estados

palfaro@0908211443
Se corrigió las posiciones de todas las etiquetas de todos los formularios para que esten alineadas con sus controles asociados
Se agrego la etiqueta Borne: en varios formularios donde faltaba
Se corrigió un error donde si uno intentaba borrar la ultima ficha de unidades de un generador se producía un acceso a memoria invalido

palfaro@0908211133
Se cambio la propiedad BorderStyle a todos los hijos de TBaseFormularios, al formulario del simulador y al formulario del SimRes3 a bsSingle, para deshabilitar el cambio de tamaño y agrandar un poco el tamaño util de la ventana
Se cambio la propiedad MainFormOnTaskBar a SimSEE, SimSEEdit y SimRes3 a true para resolver un error que no permitía minimizar las aplicaciones si se compilaban en modo DEBUG y para evitar que aparezcan múltiples iconos en la barra de tareas al ir entrando en las ediciones del editor

palfaro@0908201607
Se encontraron dos bugs en la optimización que hacían que diera resultados distintos segun se corriera multihilo o monohilo. 
El primero era en TFuenteSintetizadorCEGH ya que si la fuente no usaba variables de estado su estado no quedaba determinado por el PosicionarseEnEstrellita sino que llevaba el estado del ultimo cálculo que hubiera realizado. Ahora al PosicionarseEnEstrellita si la fuente no tiene variables de estado asigna 0 al valor de su estado (Valor Esperado)
El segundo era en los actores con iteraciones que no guardaban el valor de la iteración anterior para cada estrella, sino que se usaba el valor de la iteración de la estrella anterior calculada. Ahora piden una variable auxiliar más en la que almacenan el valor de la iteración anterior y lo restablecen al PosicionarseEnEstrellita (es un 15% más rápido que reinicializarlo en 0).
Se corrigieron bugs menores en que si no estaba el conditional define ITERAR el Editor no compilaba.

palfaro@0908191655
Se movió el procedimiento ActualizarProbabilidadesReparacionYRotura de SorteosDelPaso a CambioFichaPD para los actores que tenían el método CambioFichaPD definido
Se corrigió un bug donde los actores que redeclaraban el método Sim_Cronica_Inicio no llamaban al método de la clase madre
Se redefinio el método dump_variables de TEsclavizadorSubMuestreado para que imprima los valores de las borneras intermedias y de la esclava
Se modificó el método dump_variables de TParqueEolico para que imprima las potencias disponibles del actor
Se corrigió un bug donde solo el hilo principal de una optimización multihilo realizaba las iteraciones cuando todos deberían realizarlas
Se agrego la variable cntIteracionesDelPaso al dump_variables de TSalaDeJuego

palfaro@0908171528
Se corrigieron bugs en la implementación de las pérdidas cuadráticas de TArco
Se corrgieron varios detalles de presentación en los formularios de Alta y Edición de las demandas
Se corrigió un error en el formulario de edición de centrales encadenadas que no permitía editar las centras si quedaban solo dos centrales y ambas estaban encadenadas entre sí
Se corrigieron errores en THidroConEmbalseBinacional en donde no se inicializaban condiciones de parada de bucles, con lo que no se entraba al bucle pero el programa seguía sin error

palfaro@0908171217
Se corrigió un bug en el editor SimRes3 donde si se fallaba al cargar un archivo de definiciones no se podía volver a abrir el editor sin salir del editor SimSEE y volver a ejecutar
Se modifico el comportamiento del formulario del SimRes3 para deshabilitar los botones una vez que se hace click en ejecutar
Se modifico el mensaje de error de evalStrToFloat para que sea más descriptivo
Se modifico el comportamiento del LectorSimRes3 para que en caso de error muestre el número y la línea donde se produjo el error.
Se agrego al LectorSimRes3 que lleve la cuenta del número de parámetro que va leyendo de manera de poder especificarlo en el mensaje de error anterior.
Se quito el PE a los encabezados de las columnas de probabilidades de excedencia de los histogramas de SimRes3, el formato anterior era PEx%, el nuevo es x%

palfaro@0908141540
Se corrigió un bug en el formulario de Alta/Edición de TPrintCronVar_CompararValoresMultiplesCronVars en el que el comboBox con las cronVars mostraba 2 veces cada cronVar en el sistema.
Se corrigió un bug en el formulario de Alta/Edición de TPrintCronVar_Histograma donde si se indicaba cantidad de probabilidades de excedencia a imprimir 0 igual se chequeaba que las probabilidades estuvieran bien escritas
Se agrego a TArco que realice una aproximación a las pérdidas cuadráticas por medio del desarrollo de Taylor y las iteraciones. Falta testearlo.
Se corrigió un bug en THidroConEmbalse, THidroConEmbalseBinacional y THidroDePasada en el que no inicializaban en 0 QErogado_IterAnterior y si se ejecutaba dos veces seguidas una simulación daba resultados distintos.

palfaro@0908131432
Correciones de etiquetas en los formularios del editor
Se corrigio un bug en los formularios de Alta/Edición e printCronVars en el que no se habilitaban/deshabilitaban correctamente los edits de mínimo y máximo valor del eje x
Se agrego a THidroConEmbalseBinacional la variable QE_CEE (Caudal Erogado para Calculo de Energía Embalsada) y maxDiferenciaEnergíaEmbalsada
Se corrigió un bug en donde si uno cambiaba el orden de elementos en un listado (boton arriba o abajo) el formulario no quedaba como modificado y no preguntaba si se deseaban guardar los cambios al cerrar
Se agrego la PrintCronVar TPrintCronVar_CompararValoresMultiplesCronVars que permite realizar operaciones (por ahora promedio, desviación estandar (n-1) y probabilidad de excedencia) sobre un conjunto de cron vars, imprimir estos valores y graficarlos en un gráfico de linea o de area apilada. Se agrego tambien su formulario de alta/edicion en el editor simres3
Se agrego ITERAR y AYUDA_INDEPENDIENTE al conjunto de Conditional defines por defecto

palfaro@0908111151
Se solucionaron varios warnings del compilador
Se agrego soporte en el SimRes3 para PrintCronVars que impriman mas de una cronVar

palfaro@0908061445
Se modificaron los checkbox de los listados para que funcionen con boolToStr, si la celda tiene 0 entonces checked = false, si tiene cualquier otro valor checked = true
Se modifico la forma en que los actores imprimen los resultados de la simulación. La version anterior imprimia espacios rellenando el valor de precision especificado, la versión nueva no rellena con espacios logrando una reducción al 66% del tamaño original de los archivos simres y una mejora en la velocidad del simulador y el simres3
Se agrego el monitor MonitorSimRes, que imprime las variables seleccionadas en un archivo para cada paso de simulación. Esto permite seleccionar las columnas que uno quiere imprimir en los archivos SimRes.
Se agrego la exportación de multiples variables para poder ser impresas por el monitor SimRes. Falta publicar los costos en TGTer_ArranqueParada, TGTer_ArranqueParada_noopt, TGTer_OnOffPorPaso, TGTer_OnOffPorPaso_ConRestricciones, TGTer_OnOffPorPoste
Se agrego un método para crear el monitor SimRes por defecto que imprime las mismas columnas que imprimen los actores en el archivo simres original. Falta definir las variables por defecto para TGTer_ArranqueParada, TGTer_ArranqueParada_noopt, TGTer_OnOffPorPaso, TGTer_OnOffPorPaso_ConRestricciones, TGTer_OnOffPorPoste (los mismos de arriba)
Se extendió la función ordinalTipoCosa para todas las clases que se registran en infoCosa
Se cambio la forma en que se publican las variables reales para poder especificar precisión y decimales
Se cambio la forma en que se publican los vectores para poder especificar nomenclatura normal (vector[i]) o nomenclatura por poste (vector_Pi)
Se agrego el método setIndice a TDefVar para poder especificar el indice que ocupa una def var si es parte de un arreglo.
Se modificó la publicación de variables para que la sala de juegos y las fuentes aleatorias puedan publicar sus variables.


palfaro@0907241700
Se corrigió un bug donde el botón ver fichas expandidas de los formularios de edición de fuentes aleatorias no funcionaba
Se modifico TFuenteSintetizadorCEGH para que acepte fichas con parametros dinámicos modificando el valor esperado del estado y varianza de los sorteos de la fuente
Se modificó el editor de TFuenteSintetizadorCEGH para soportar este cambio. Ademas se permite cambiar el archivo del sintetizador manteniendo los valores esperados y varianzas para bornes que se encontraran en el archivo original
Se cambio el visor de fichas expandidas para que funcione con cosas con nombre en vez de con actores

palfaro@0907211609
Se modifico TReferenciaMonUnivar para que tenga un objeto de tipo TReferenciaDefVar en vez de manejar el la referencia directamente
Se agregaron notificaciones al editar una variable de un monitor si no se encuentra el actor o la variable
Se modifico la forma de cargar los monitores en el editor a la provista por la clase (de forma de cargarlos de la misma manera desde todos los proyectos) y se agregaron mensajes de advertencia si no se puede resolver alguna de las referencias a variables de los actores

palfaro@0907211240
Se corrigió un bug del editor SimRes3 donde las funciones TDAOfTVarIdxsToString, TDAOfCronVarToString y TDAOfStringToString que convierten arreglos de distintos tipos de elementos a string retornaban el string vacío si el arreglo tenía tamaño 1.
Se corrigió un bug donde no se mostraba correctamente la versión del editor al arrancar
Se corrigieron errores menores de presentación
Se corrigió un bug en TAltaDemandaAnioBaseEIndices y TEditarDemandaAnioBaseEIndices donde los botones de exportar e importar a excel se superponían con la barra de progreso y las etiquetas de información.
Se modificaron los formularios de alta y edición de TParqueEolico para que solo desplieguen las fuentes aleatorias con duración de paso de sorteo 1 hora y se agrego un mensaje indicando que no las hay en caso de no haberlas
Se agrego un mensaje de información si se intenta editar centrales encadenadas y no hay mas centrales hidráulicas en la sala
Se corrigió un bug en los formularios de alta/edición de TFichaFuenteGaussiana y TFichaFuenteUniforme donde se advertia al usuario que había ingresado mal los valores en la tabla aún si no había ingresado nada.
Se corrigió un bug donde si se guardaba la sala de juegos no se le asignaba el directorio de corrida (esto causaba que anduviera mal el ejecutar SimRes3)
Se corrigió un bug donde si los nombres de los actores contenían espacios estos no eran bien cargados en TAltaIdxs
Se agregó a THidroConEmbalse que imprima el valor de h_real en sus resultados y que publique la variable


palfaro@0907161455
Se agrego un chequeo al editor para que evite cargar una sala si se le pasa un archivo por linea de comandos y el archivo no existe. Se hizo lo mismo con los monitores.
Se agrego a la clase TVarDef el campo unidad para especificar la unidad de una variable publicada. Esto se aplica a todas las TVarDefs excepto las fechas
Se modifico a todos los actores para que especificaran en sus publicaciones de variables las unidades
Se modifico el método de lectura de TReferenciaMonitorUniVar y TReferenciaVarDef para que eliminen la unidad del nombre de la variable de modo de poder volver a encontrarla con la nueva publicacion
Se modifico TMonitorSimRes para que imprima los encabezados de las columnas igual a como lo hacía el método sim_PrintResultados_Encab

palfaro@0907151500
Se modificaron los formularios de Alta/Edición de monitores para evitar código duplicado. Se agrupo mayormente el código de mensajes de error en la clase base de estos formularios y se dejo mas clara la validacion de cada formulario
Se agrego el monitor TMonitorSimRes (aun en desarrollo, falta completar información en los encabezados de las columnas) que permite generar un archivo SimRes seleccionando las columnas que uno desee.
Se agrego el formulario de Alta/Edición de TMonitorSimRes

palfaro@0907141519
Se elimino un duplicado de la lista de iconos en el Editor SimSEE. La lista se encuentra ahora en TBaseFormularios
Se corrigió un bug en TEditarMensaje donde si se daba cancelar sin haber modificado nada preguntaba si se deseaban guardar los cambios.
Se agrego la posibilidad de modificar el orden de las variables en los monitores de archivos y de las series en los monitores gráficos simples.
Se ordeno por tipo de actor la lista de actores para exportar de modo de poder encontrar mas facilmente los actores que se desea exportar.
Se ordeno por tipo de actor la lista de actores con variables publicadas de modo de poder encontrar mas facilmente el actor del cual se desea monitorear una variable.
Se modifico el comportamiento de tomar el valor de una variable fecha como string para que retorne la fecha en formato ISO
Cambios menores de rendimiento en el manejador de monitores
Se agregaron comentarios explicativos a varias clases y se corrigieron comentarios de clases antiguas
Se agrego el tipo color a los tipos de columna posibles de un listado

rchaer@0907141630
En las últimas semanas cambie algunos modelos.
Se corrigieron varios errores del actor central térmcia con restricciones de tiempo de prendido y apagado.
Se mejoro el modelo de Central Hidro Sin Embalse para que si puede calcular su caudar erogado al inicio del paso no 
haga una aproximación del ce sino que lo calcule de una. Para esto, la central verificia
si tiene centrales aguas arriba. Si no tienen centrales aguas arriba, su caudal erogado será
directamente su caudal de aportes.

palfaro@0906031429
Se corrigió un bug en THidroConEmbalse en el que se contaba mal la cantidad de centrales aguas abajo y se generaba un error de memoria
Se corrigió un bug en THidroConEmbalse donde se limitaba el vertimiento máximo de la central a valores muy pequeños pero luego se le especificaba al simplex que podía violar la restricción para satisfacer el problema. De esta forma el simplex perdía tiempo intentando resolver el problema sin violar la restricción para luego terminar violandola.
Se corrigió un bug en SimSEEEdit donde si se cargaba una sala con descripción se preguntaba si se quería guardar los cambios al salir aunque no se hubiera modificado nada
Se corrigió un bug en SimSEEEdit donde las tablas para ingresar valores no validaban los valores ingresados correctamente

palfaro@0906021222
Se corrigió la implementación del editor SimRes3 para soportar comentarios en los archivos de definición. Se puede agregar, mover de lugar, eliminar y modificar objetos y los comentarios serán respetados en la posición en que estaban.
Se cambió el funcionamiento de los botones de arriba y abajo de los listados al mantener SHIFT apretado. Antes se intercambiaba la fila clickeada por la primera (o la última), ahora se mueve la fila hasta el primer (o último) lugar desplazando todos los elementos entre la fila y la fila destino un lugar hacia abajo (o hacia arriba) y se agrego un parametro para especificar una acción al intercambiar dos filas
Se cambió el diálogo de al guardar un archivo simres que preguntaba si se debían eliminar los indices y cronvars eliminados, ahora pregunta si se deben conservar y se debe hacer click en no para eliminarlos

palfaro@0906011535
Se corrigió un bug donde las fuentes de tipo TFuenteSintetizadorCEGH utilizaban los valores determinísticos de los primeros pasos de sorteo incorrectamente durante la optimización. Ahora NO se usan los valores deterministicos en la optimización, solo se usan en los primeros pasos de la simulación.
Se corrigió un bug donde las variables auxiliares de la optimización no eran inicializadas en 0 al optimizar, por lo que si se optimizaba 2 veces consecutivas los actores cargaban valores de las variables auxiliares resultantes del ultimo paso de la optimización anterior (en vez de 0) produciendo resultados distintos.
Se corrigió un bug en la optimización multi-hilo donde si se optimizaba 2 veces consecutivas las estrellas no eran asignadas correctamente a los hilos.

palfaro@0905131615
Se corrigieron un bug en que los monitores no se cargaban correctamente en la versión de linea de comandos del simulador. Si estaba el conditional define MONITORES ejecutar un cmdopt lanzaba un error de memoria, aunque no se usaran monitores
Se agrego soporte para listados editables en utilidades
Se modifico el formulario de edición de fichas de unidades para permitir modificar las fechas y cantidades de unidades directamente desde la tabla sin tener que entrar al formulario de edicion de las fichas
Se agrego en la pestaña mantenimientos un listado con todos los mantenimientos de los generadores del sistema editables de la misma manera que se indica en el punto anterior
Se agrego la extension por defecto .txt a los archivos del editor SimRes3
Se corrigió un bug del editor simres3 donde el caption de la ventana no se actualizaba al crear un nuevo archivo
Se modifico visorPolOpt para que pueda leer los archivos optRes con el nuevo formato
Se agrego en TResultadoOpt la traducción de las variables que la tengan
Se modifico el procesador de resultados para permitir visualizar la variable fija con o sin traducción en caso de tenerla
Se agregaron metodos para habilitar y deshabilitar las alertas en TGlobs
Se corrigió un error en la optimización multihilo donde en LINUX un orden de ejecución determinado hacía que se crearan primero eventos transmisores antes que sus respectivos receptores, los transmisores fallaban en la creación (sin mensaje de error) y los receptores quedaban trancados esperando la respuesta.
Ahora si un transmisor se crea antes que su receptor se lanza una excepcion y se corrigió el comportamiento de la optimización multi core para evitar esto.
Se agrego a la optimizacion multi core que eleve las excepciones que reciba
se agrego el metodo CargarManejadorDeMonitores a la clase TManejadorDeMonitores para cargar un manejador directamente con el nombre de archivo


palfaro@0905061511
Se cambio la forma de mostrar los hints en las tablas recortadas sin scroll horizontal, ahora se usa el hint del componente en vez de TCustomHintWindow
Se agrego una barra de progreso a las exportaciones/importaciones de Excel para los formularios como el de crearBinDatosHorarios en que la cantidad de datos a importar/exportar puede ser muy grande
Se agrego un dialogo de confirmacion que advierte que la exportacion a Excel puede demorar cuando la cantidad de celdas a exportar excede las 20000
Se corrigieron errores en los nombres de las variables en los formularios de alta y edicion de TParqueEolico


palfaro@0905051448
Se agrego a TExcelFile el metodo writeBuffereado que guarda un valor en un buffer para ser escrito con el próximo salto de línea, reduciendo las llamadas al objeto excel y acelerando la escritura
Se modificaron los prints del SimRes3 para que usen el writeBuffereado
Se modifico la exportación de tablas a Excel para que usen el writeFila agregado ayer
Se corrigió un bug en el formulario de edición de TFuenteSintetizador en el que los valores de las fichas de determinismos se presentaban sin separador entre ellos
Se corrigió un bug en los formularios de edicion de generadores térmicos y arcos donde la lista de fichas de parámetros dinámicos no se desplegaba correctamente si la alutar de la tabla excedía los 153 pixeles
Se modifico el metodo DumpSistemaToXLT de TSimplex para imprimir correctamente la lista de violaciones permitidas
Se modifico el metodo ResolverReferenciasYCargarSimplex de TFormTestSimplex para cargar correctamente la lista de violaciones permitidas, en lugar de la unica violacion permitida de la version anterior

palfaro@0905041532
Se corrigió un bug en TPostOperMultiCronVar.referenciaCronVar donde no se chequeaba si se referenciaba a la CronVar resultado
Se agrego la posibilidad de ejecutar un archivo SimRes3defs directamente desde el editor
Se agrego la CronOper filtrar crónica que solo procesa los resultados si la crónica es la indicada
Se agregaron los métodos WriteFila y WriteLnFila a la clase TExcelFile que llenan una fila de una sola pasada para reducir el tiempo de exportacion a excel. En ejecuciones de simres con muchas crónicas e impresion de matrices de datos el tiempo empieza a representar un problema.

palfaro@0904291555
Se modifico el formulario de creación de archivos binarios de datos horarios para que pida el nombre del archivo al dar guardar, y no que aparezca como un campo mas del formulario.
En las exportaciones/importaciones de EXCEL se cambia el cursor del mouse al cursor de trabajando para cuando se desean exportar o importar grandes cantidades de datos

palfaro@0904281511
Se agrego como parámetro el tiempo de reparación en horas a TArco, TGter_Basico, TGter_ArranqueParada, TGter_ArranqueParada_noopt, TGter_OnOffPorPaso, TGter_OnOffPorPoste, THidroConEmbalse y THidroDePasada, y TParqueEolico
Se corrigió un bug en TParqueEolico en que se cuando realizaba la verificación de que la fuente tuviera paso horario, si la fuente tenía paso 0 y la sala duracion del paso 1, de todas formas lanzaba una excepción.
Se corrigió un bug en el editor de TParqueEolico en el que el editor no validaba que la fuente seleccionada tuviera paso horario pero el actor si, por lo que si uno salvaba el actor y la fuente no tenía paso horario perdía los cambios. Ahora ambos validan el paso horario de la fuente
Se agrego al formulario de selección de tipo que si se hace doble click en un elemento del listado, este sea seleccionado como si se hiciera click en el boton aceptar
Se modifico el formulario de edición de TFichaHidroConEmbalse para que ocupara menos espacio vertical y cupiera mejor en pantallas wide.

palfaro@0904281209
Se corrigieron errores de presentación para la resolución 800x600
Se agrego a las opciones del editor el deshabilitar el scroll horizontal en los listados. Si esta marcada los listados achicaran las columnas mas grandes cortando su texto hasta que quepa todo en la pantalla. Para ver el texto completo basta con pasar el mouse por encima del listado. Esta opción viene en true por defecto.
Se movio la clase TSimSEEEditOptions a su propia unidad y se la incluyo en todos los formularios del editor de modo de poder acceder a las opciones desde ellos (p.ej el deshabilitar scroll en las tablas).
Se cambio el posicionamiento de las ventanas del editor para asegurar que no se creen fuera de la pantalla si es posible no hacerlo.
Se creo la clase TCustomHintWindow que realiza la misma función que el hint de los controles, pero controla que el recuadro no se salga de pantalla.
Cuando se hace click en la flecha hacia arriba o hacia abajo de un listado el puntero del ratón se posiciona automaticamente en la nueva fila correspondiente al objeto.

palfaro@0904211439
Se corrigó un bug con el parpadeo del boton de la barra de tareas en que si la aplicación no tenía consola el boton no parpadeaba
Se corrigió un bug en el editor de SimRes3 en que si se cargaba un archivo con referencia a actores de otra sala y no se editaban los actores se accedia a un lugar fuera de la memoria del proceso
Se agrego al editor SimRes3 que al guardar verifique si hay índices o CronVars no utilizados y despliegue un mensaje al usuario permitiendo eliminarlos.

palfaro@0904201357
Se agregaron métodos a TLectorSimResDefs para validar los nombres de CronVars, Indices y las hojas de un TPrintCronVar.
Se agrego al formulario de edición principal que la sala deba estar guardada para poder utilizar el editor de SimRes3.
Se agrego un botón de ayuda al solapero principal del editor SimRes3
Se agrego a todos los formularios de edición de cosas con nombre del editor que la barra de títulos despliegue el nombre. Asímismo los formularios de edición de cosas subordinadas a una cosa con nombre (como las fichas periodicas) despliegan el nombre de su dueño en la barra de título.
Se agrego al simulador que si se corre en modo DEBUG se genere una aplicación de consola para poder escribir.
Se agregaron etiquetas en la barra de progreso del SimRes3 indicando el 0, 25, 50, 75 y 100% del progreso respectivamente.
Se creo la clase TResultadoOpt para leer archivos optRes y realizar cálculos sobre ellos. En particular permite manipular una variable fijando el valor del resto y observar los resultados a medida que varía la variable libre, y permite en forma básica (limitado a la variable bonete y a un estado hidrlógico de 5 discretizaciones) comparar el valor de la variable contra un nivel de corte especificado.
Se modifico la clase TSimplex para permitir violar la restricción de caja de multiples variables para resolver una restricción. Esto permite resolver la restricción de cota de los embalses en caso de que dos embalses encadenados este cerca de su límite de volumen. Si el de arriba precisa verter mas de lo permitido viola su restricción, pero luego el de abajo debe poder verter mas de lo permitido para recibir el caudal del generador aguas arriba.


palfaro@0904161611
Se agrego a los formularios de edición de fichas el nombre del actor en la barra de título de la ventana
Se modificaron los listados del editor para que muestren seleccionada la fila del objeto (actor, fuente, ficha, etc) que fue modificado en el ultimo editar o de un nuevo objeto creado en un clonar
Se corrigió un bug en TSimplex.intentarModificarCotaSupParaResolverRes. Si la variable al que se le iba a modificar la cota superior se encontraba en una fila, la busqueda se detenía en la ultima fila mientras que la iteración se realizaba en las columnas.
En el mismo método si se encontraba una modificación para hacer se hacía en las ecuaciones, pero no se cambiaba la cota superior de la variable ni se marcaba la ficha como usada o incrementaba la cantidad de violaciones permitidas utilizadas. Estos 3 errores fueron corregidos.

palfaro@0903311348
Se modifico el método de escritura de TLectorSimRes3Defs para que todas las strings se ecriba entre '"' si tienen espacios en el medio.
Se agregaron métodos informativos a todas las TCronOper, TPostOper y TPrintCronVar. Estos métodos permiten visualizar la información más rápidamente y sumarizada en el editor, así como detectar referencias entre los objetos.


palfaro@0903271747
Se agrego el editor de plantillas de SimRes3 dentro del menú herramientas de SimSEEEdit

Se agregaron funciones en TBaseFormularios para manipular listas de Strings con una TStringGrid, un TEdit y un TButton, se pueden setear el valor de la lista en pantalla, agregar un valor a la lista, eliminar un valor de la lista y validarla antes de guardar.
Se agregaron funciones en TBaseFormularios para manipular vectores de reales con una TStringGrid, un TEdit y un TButton. Se puede realizar lo mismo que arriba, con la salvedad que las validaciones son verificar que todo lo introducido sea numerico, o númerico y ordenado o numerico y dentro de un rango.

Se agregaron funciones en TBaseFormulariosSimRes3 para manejar selecciones de TVarIdxs con un TComboBox. Se puede setear el valor en pantalla, validar y obtener el valor del combobox, permiten ingresar valores nulos con una flag y se hace una anticipación menor de los comandos del usuario.
Se agregaron funciones en TBaseFormulariosSimRes3 para manejar selecciones de TCronVars con un TComboBox. Igual que para los indices.

Se agregaron funciones en TBaseFormulariosSimRes3 para manipular listas de índices con una TStringGrid, un TComboBox y un TButton. Mismas funciones que para la lista de strings, con validaciones extra y anticipación de los comandos del usuario.
Se agregaron funciones en TBaseFormulariosSimRes3 para manipular listas de indices con coeficientes con una TStringGrid, un TComboBox, un TEdit y un TButton. Igual que la lista de indices
Se agregaron funciones en TBaseFormulariosSimRes3 para manipular listas de indices con coeficientes y desplazamientos con una TStringGrid, un TComboBox, dos TEdits y un TButton. Igual que la lista de indices


palfaro@0902191551
Se agrego a los formularios de alta y edición de TParqueEolico la posibilidad de importar y exportar a excel la tabla con los factores de speed up.
Se corrigió un bug donde varios formularios de alta y edicion de actores no tenían un método asignado al botón de ayuda. Ahora despliegan la ayuda correctamente.
Se creó una página de ayuda para cada formulario copiando de los archivos de ayuda en caso de que ya existieran y marcando la página como TO DO en caso de que no. Queda pendiente agregar las imágenes y corregir los links.
Se creo la unidad uBarredorCarpetas.pas y las clases TBarredorCarpetas y TBarredorCopiador.
TBarredorCarpetas es una clase abstracta que recorre una carpeta especificada buscando archivos que cumplan con una mascara. En caso de encontrar un archivo llama al método procesarArchivo que será implementado por las clases que hereden de ella.
TBarredorCopiador hereda de TBarredorCarpetas y implementa el método procesarArchivo realizando una copia del archivo encontrado en una carpeta especificada conservando el arbol de directorios.

palfaro@0902181601
Se renombro la unidad uExcelExports.pas a uExcelExportImport.pas y se le agregaron nuevos métodos para exportar e importar datos desde y hacia excel. Estos métodos mantienen abierto el libro de trabajo y copian los valores hacia el y de el, sin necesidad de copiarlos en el formulario intermedio de los métodos anteriores.
Se agrego la opción de importar a todos los tipos de días en la edición de fichas de TDemanda01 en vez de tener que ir importando día por día
Se corrigió un bug en el editor donde si se modificaba una fuente los monitores quedaban como no salvados aunque la fuente no fuera referenciada por ningún monitor.
Se cambio la implementación de TMercadoSpotConDetalleHorarioSemanal para que tenga un delta costo en vez de un multiplicador de costo, que incluya en sus parámetros dinámicos dos fuentes aleatorias que actuen como multiplicadores uno de las potencias mínimas y otro de las máximas y se adapto al actor para que sepa ordenar sus horas segun el orden impuesto por la postización de la demanda principal

palfaro@0902171157
Se agrego el método infoAd a las fichas de párametros dinámicos de todos los actores y todas las fuentes disponibles en SimSEE
Se corrigió un bug donde el orden de tabulación de los controles de los formularios no era el correcto. Ahora el orden de tabulación se determina de arriba hacia abajo y de izquierda a derecha.
Se agrego el actor TMercadoSpotConDetalleHorarioSemanal que actua inyectando o tomando energía del sistema a un costo dado por una fuente aleatoria y permite indicar para cada hora de la semana una potencia mínima y máxima de oferta o demanda y un multiplicador de costo.

palfaro@0902131123
Se corrigió un bug en TSintetizadorCEGH donde al calcular los valores del estado siguiente se utilizaban los deformadores correspondientes al tiempo actual y no los correspondientes al próximo paso de sorteo
Se agrego el actor TMercadoSpotConDetalleHorarioSemanal y sus formularios de alta, edición y edición de fichas
Se corrigió un bug menor donde el formulario principal dejaba editar el memo de advertencias
Se creó la unidad uimpmatnreal.pas para poder importar matrices de números reales
Se agrego a uimpvnreal una funcion para poder especificar el tamaño deseado del vector de datos.
Si la cantidad de datos importados no coincide con el tamaño especificado despliega un mensaje de error
Se agrego la unidad uExcelExports.pas para exportar datos hacia una hoja de calculo de excel y se le agregaron dos métodos para exportar TStringGrids, uno para exportar bloques contiguos de la tabla y otro para exportar solamente las columnas especificadas
Se corrigió un bug en el SimRes3 donde no se hacia ningún control sobre el horizonte de fechas en el cual tomar los datos. Ahora si tanto la fecha inicial como la final son menores que la fecha de inicio de la simulación se fijan en la fecha de inicio de la simulación y si son mayores que la fecha de fin de la simulación se fijan en la fecha de fin de la simulación

palfaro@0902041451
Se corrigio un bug en TSintetizadorCEGH donde al volver al inicio de los datos en una serie historica se sincronizaba el indice del arreglo un paso de tiempo antes del debido

palfaro@0902041130
Se corrigió un bug en el simulador donde se lanzaba un error de memoria si la sala no se podía cargar correctamente

palfaro@0902031657
Se corrigió un bug donde el formulario de Alta de Demanda Anio Base e Índices no se mostraba correctamente

palfaro@0902031234
Se corrigió un bug donde al editar actores, fuentes o monitores los directorios por defecto de los campos de busqueda no se inicializaban correctamete.

palfaro@0902021115
Se corrigió un bug en TSintetizadorCEGH donde simular con una serie de datos históricos provocaba un error de memoria
Se agrego documentación a la clase TSintetizadorCEGH explicando como se distribuyen los valores de ruidos blancos, estado, estado siguiente y bornes calculados dentro de su bornera

palfaro@0901301615
Se agrego a TSintetizadorCEGH la opción de utilizar una serie de datos históricos como valores de sus sorteos para la simulación y se modifico el formulario de edición de la fuente para poder ingresar estos nuevos datos

palfaro@0901251232
Se corrigió un bug donde las instancias de la clase TRobotOptimizadorMultiHilo no se liberaban correctamente en Free Pascal y el programa mostraba un mensaje de error al finalizar.

palfaro@0901131553
Se cambio la implementacion de la optimización multi core para que funcione con los semaforos de linux o windows.
Se corrigió un bug donde no se liberaba uno de los eventos de la optimizacion multi core
Se corrigió un bug donde el método cargarSala de TSalaDeJuego abortaba sin lanzar ningun error si el archivo especificado no existia


palfaro@0901071207
Se cambio el archivo excel con el resumen de los generadores térmicos por un archivo de texto separado
por tabuladores para evitar la dependencia entre los actores y excel

palfaro@0901051631
Se agrego la opción de generar un archivo excel con un resumen de los generadores térmicos de la sala de juego

palfaro@0812261508
Se corrigió un bug en la versión de linea de comandos del optimizador en el que si había un error al
cargar la sala el programa salía sin indicar el error. Ahora escribe el error en pantalla y aborta.

palfaro@0812261457
Se corrigió un bug al importar un actor donde importar actores con nombres repetidos corrompía la sala.
Se cambió el criterio de identificación de los actores. El identificador es solo el nombre, es decir no pueden haber dos actores distintos con nombres iguales

palfaro@0812261226
Se cambio el formulario de edición de fuente de sintetizador para que diga que la cantidad de pasos deterministicos es la cantidad de pasos de SORTEO deterministicos
Se cambio el formulario de edición de fuente de sintetizador para que diga la duración del paso de sorteo de la fuente

rch@0812191046
Pablo, poné pa@aammddhhmm cuando anotes 
para que se sepa el autor del registro.

rch@0812191046
Corregí error en Demanda AnioBase. Faltaba un -1
en un for y escribía fuera de memoria.

rch@0812191046
SimRes3 - Cambiamos la postoper de cálculo de la potencia
firme hidráulica con Brandino.
Ahora calcula la Potencia con prob de excedencia 95%
de la suma de las potencias y luego busca para cada
central por separado pero con igual
prob. de excedencia en todas las potencias individuales
que sumadas dan más cerca de la P95 calculada para la suma


10/12/2008
SimRes3
Se corrigió un bug donde el archivo de definición podía indicar un archivo que no existiera. Ahora se chequea que el archivo exista antes de abrirlo.

02/12/2008
SimSEESimulador
Se corrigió un bug en la optimización multihilo donde se asignaba en cada paso la semilla inicial de cada hilo y luego era ignorada. En una corrida multihilo local cada hilo realizara los mismos sorteos por lo que no es necesario asignarle la semilla paso a paso. Este cambio no afecta los resultados anteriores.

28/11/2008
SimSEESimulador
Se corrigió un bug donde la optimización multi hilo no creaba la carpeta de corrida de la sala

26/11/2008
SimRes3
Se agrego la CronOper combinar
Se agrego a todas las CronOpers un método ayudaCronOper para que especifiquen su sintaxis y una descripción

SimSEESimulador
Se corrigió un bug en que la memoria de la función de costo futuro era liberada por todos los hilos en la optimización multi hilo. Ahora solo el hilo principal la libera.

18/11/2008

SimSEESimulador
Se corrigió un bug donde al intentar importar un actor permitía especificar archivos que no fueran .act
Se corrigió un bug donde la ruta inicial del importar actor no coincidia con la ruta a la librería de actores

14/11/2008

SimSEESimulador
Se cambio la forma de promediar los sorteos. Antes se acumulaban todos los resultados y al final se dividían entre la cantidad de crónicas. Ahora se acumulan ya divididos entre la cantidad de crónicas para reducir errores numéricos.
Se corrigió un error en el que se calculaban mal los vectores de estado auxiliares del los actores. Se dividian entre la cantidad de cronicas y se swapeaban para cada estrella en vez de para cada paso.

SimSEEEdit
Se corrigió un error en el que la ruta de las librerías se guardaba la unidad. Ahora queda en la misma unidad que se encuentre el ejecutable.
Se corrigió un error al importar actores en el que un error al cargar un actor dejaba referencias sin resolver y luego no permitía importar mas actores. Ahora si falla la carga se limpian las referencias que hubieran sin resolver.
